# Sketchup.active_model.selection[0]

#__FILE__ is the filename with extension of the file containing the code being executed.
#In foo.rb, __FILE__ would be "foo.rb".
#If foo.rb were in the dir /home/josh then File.dirname(__FILE__) would return /home/josh


#faire appel à un script quand l'utilisateur clique sur un lien :     <A HREF="javascript:ma_fonction()">Cliquez ici</A>


#--------------------------------------------------------------------------------
#                                         Dialogs                                                            
#--------------------------------------------------------------------------------

def setValue(dlg,id,value)
	new_value=value.to_s
	cmd="document.getElementById('#{id}').value=\"#{new_value}\""
	dlg.execute_script(cmd)
end

def getValue(dlg,id)
	cmd="document.getElementById('#{id}').value"
	dlg.execute_script(cmd)
end

def linkToolsWebDialog()
	@dialog = UI::WebDialog.new "Links",false,false,100,100,0,0,false
	#html = Sketchup.find_support_file("Plugins")+"\/Links Manager\/fr_linkTools.html"
	html=File.dirname(__FILE__) +"\\linkTools.html"
	@dialog.set_file(html,nil)
	
	# Page loaded ?
	@dialog.add_action_callback("main_dlg_loaded") { |d, p|
		#Fill dialog with actual values
		setValue(@dialog,"urlLink",@link.url)
		setValue(@dialog,"urlDescr",@link.urlDescr)
		setValue(@dialog,"filLink",@link.fil)
		setValue(@dialog,"filDescr",@link.filDescr)
	}
  
	# Browse button hit
	@dialog.add_action_callback("main_dlg_browse") { |d, p|
		f=UI.openpanel("Select file to link")
		#setValue(@dialog,"filLink",f.split("\\").last)
		setValue(@dialog,"filLink",f.gsub("\\","\/")) if f
	}
  
	# OK button hit
	@dialog.add_action_callback("main_dlg_ok") { |d, p|
		# Get values from the dialog
		@link.url=@dialog.get_element_value("urlLink")
		@link.urlDescr=@dialog.get_element_value("urlDescr")
		@link.fil=@dialog.get_element_value("filLink")
		@link.filDescr=@dialog.get_element_value("filDescr")
		# Set them as attributes:
		@link.setLinks()
		# Close dialog
		@dialog.close()
	}
  
	# Cancel button hit: nothing to do
	@dialog.add_action_callback("main_dlg_cancel") { |d, p| @dialog.close }
	
	# Init size and pos of dialog
	@dialog.set_size 600, 450
	#@dialog.set_position 400, 300
	@dialog.show_modal {}
end

def mediaWebDialog(f)
	@dialog = UI::WebDialog.new "Media",nil,true,100,100,0,0,true
	status= @dialog.set_file(f,nil)
	@dialog.show {} 
end


#--------------------------------------------------------------------------------
#                                         Link Object                                                      
#--------------------------------------------------------------------------------

class SU_Link
	attr_accessor :url
	attr_accessor :urlDescr
	attr_accessor :fil
	attr_accessor :filDescr
	attr_accessor :su_obj

    def initialize(su_obj)
		@su_obj=su_obj
		# Retrieve links if any
		dicts=@su_obj.attribute_dictionaries
		if( dicts!= nil and dicts["link_data"] )
			@url = @su_obj.get_attribute("link_data", "URL")
			@url="" if !@url
			@urlDescr = @su_obj.get_attribute("link_data", "URL Description")
			@urlDescr="" if !@urlDescr
			@fil = @su_obj.get_attribute("link_data", "FILE")
			@fil="" if !@fil
			@filDescr = @su_obj.get_attribute("link_data", "FILE Description")
			@filDescr="" if !@filDescr
		else
			@url = @urlDescr = @fil = @filDescr = ""
		end
    end
	
	def setLinks()
		@su_obj.attribute_dictionary("link_data", true)
		if @url!=""
			@su_obj.set_attribute("link_data","URL",@url)
			@su_obj.set_attribute("link_data","URL Description",@urlDescr)
		end
		if @fil!=""
			@su_obj.set_attribute("link_data","FILE",@fil)
			@su_obj.set_attribute("link_data","FILE Description",@filDescr)
		end
	end
	
	def openURL(kind)
		case kind
			when "url"
				if self.url!=""
					UI.openURL(self.url)
				else
					UI.messagebox("No link set for this object ( " + @su_obj.typename.to_s + ")")
				end
			when "file"
				if self.fil!=""
					UI.openURL("file://" + self.fil)
					#mediaWebDialog(self.fil)
				else
					UI.messagebox("No file linked to this object (" + e.typename.to_s + ")")
				end
		end
	end
	
	def deleteURL(kind)
		case kind
			when "url"
				@su_obj.attribute_dictionaries["link_data"].delete_key("URL")
				@su_obj.attribute_dictionaries["link_data"].delete_key("URL Description")
			when "file"
				@su_obj.attribute_dictionaries["link_data"].delete_key("FILE")
				@su_obj.attribute_dictionaries["link_data"].delete_key("FILE Description")
		end
		return
	end

end # of Class


#--------------------------------------------------------------------------------
#                                         Link Tool                                                          
#--------------------------------------------------------------------------------

class LinkTool
	
	def initialize()
		@model=Sketchup.active_model
		@ents=@model.active_entities
		@target=nil
		@link=nil
		@ctrl=false
		@shift=false
		@alt=false
		@cursorpathblank=Sketchup.find_support_file("Plugins/")+ "/Links Manager/linktool1_24.png"
		@cursorpathlink=Sketchup.find_support_file("Plugins/")+ "/Links Manager/linktool2_24.png"
		@idcursorblank = UI::create_cursor @cursorpathblank, 0,0 if @cursorpathblank
		@idcursorlink = UI::create_cursor @cursorpathlink, 0,0 if @cursorpathlink
		@ph=@model.active_view.pick_helper
	end
	
	def activate
		Sketchup::set_status_text("Click to set links, ALT-Click to delete links, CTRL-click to open link(s), Shift to display link(s)", SB_PROMPT)
	end

	def onSetCursor
		if @target and (@link.url!="" or @link.fil!="")
			UI::set_cursor @idcursorlink
		else
			UI::set_cursor @idcursorblank
		end
	end
	
	def objectAtScreenLocation(x,y,view)
		n=@ph.do_pick(x,y)
		return nil if n==0
		return @ph.best_picked
	end
	
	def deactivate(view)
		view.invalidate
		self.reset(view)
		Sketchup::set_status_text("")
	end
	
	def onMouseMove(flags, x, y, view)
		Sketchup::set_status_text("Click to set links, ALT-Click to delete links, CTRL-click to open link(s), Shift to display link(s)", SB_PROMPT)
		@target=objectAtScreenLocation(x,y,view) if @ph
		if @target
			@link=SU_Link.new(@target)
			self.highlight()
		elsif @shift
			self.highlightAll()
			@shift=false
		end
		view.invalidate
	end
	
	def onLButtonDown(flags, x, y, view)
		if @target
			#Open link(s)
			if (@link.url!="" or @link.fil!="") and @ctrl==true and @alt==false and @shift==false
				@ctrl=false
				Sketchup::set_status_text("Opening " + @link.urlDescr << " " << @link.url)
				@link.openURL("url") if @link.url!=""
				Sketchup::set_status_text("Opening " + @link.filDescr << " " << @link.fil)
				@link.openURL("file") if @link.fil!=""
				return
			end
			# Set new link(s) or modify link(s)
			if @ctrl==false and @alt==false and @shift==false
				linkToolsWebDialog()
			end
			# Delete link(s)
			if (@link.url!="" or @link.fil!="") and @ctrl==false and @alt==true
				if @link.url!=""
					answer=UI.messagebox("Delete link to:\n" + @link.urlDescr << " \n" << @link.url << " ?", MB_YESNO)
					@link.deleteURL("url") if answer==6
				end
				if @link.fil!=""
					answer=UI.messagebox("Delete link to:\n" + @link.filDescr << " \n" << @link.fil << " ?", MB_YESNO)
					@link.deleteURL("file") if answer==6
				end
				@alt=false
			end
		end
	end
	
	def onKeyDown(key, repeat, flags, view)
		case key
			when VK_CONTROL 
				@ctrl=true
			when VK_SHIFT
				@shift=true
				self.highlightAll()
			when VK_ALT
				@alt=true
		end
	end
	
	def onKeyUp(key, repeat, flags, view)
		case key
			when VK_CONTROL 
				@ctrl=false
			when VK_SHIFT
				@shift=false
			when VK_ALT
				@alt=false
		end
	end
		
	def onReturn(view)
		self.reset(view)
		Sketchup::set_status_text("")
		@model.selection.clear
		@model.select_tool(nil)
	end
	
	def onCancel(flag, view)
		self.reset(view)
		Sketchup::set_status_text("")
		@model.selection.clear
		@model.select_tool(nil)
	end
	
	def reset(view)
		if view
			view.tooltip = nil
			view.invalidate
		end
		@model.selection.clear
	end
	
	def draw(view)
		ttip="     "
		if @target 
			if @link.url!=""
				ttip << @link.urlDescr << "\n     " << @link.url
			end
			if @link.fil!=""
				ttip << "\n     " << @link.filDescr << "\n     " << @link.fil.split("\/").last
			end
			if @link.url=="" and @link.fil==""
				ttip << "Click to link"
			end
		else
			ttip << "No object here"
		end
		view.tooltip=ttip
	end
	
	def highlight()
		@model.selection.clear
		@model.selection.add(@target)
	end
	
	def highlightAll()
		@model.selection.clear
		@ents.each do |e|
			link=SU_Link.new(e)
			@model.selection.add(e) if link.url!=""
			@model.selection.add(e) if link.fil!=""
		end
	end
	
end # class LinkTool